/*
* A graph object that contains numerous connected vertices and the different traversal/path
* algorithms implemented
* (this is the real "meat" of the project)  
* @author Richard Grube
*/

import java.io.*;
import java.util.StringTokenizer;


public class Graph {
	public Vertex vertices[]; //important array, what this object is "made" of
	
	/*
	* the following 3 instance variables are used in their respective traversal algorithms
	* to assist in storing cities that are important to the algorithm outside of a single
	* method's scope
	*/
	private int dfsFound[];
	private int dfsCount;	
	private int bfsFound[];
	
	/*
	* Large constructor - its job is to read the graph file and read all the vertices/edges into 
	* objects and variables
	*/
	public Graph() {
		this.dfsFound = new int[113];
		this.bfsFound = new int[113];
		
		FileReader reader;
		BufferedReader input;
		FileReader reader1;
		BufferedReader input1;
		this.vertices=new Vertex[113];
				
		String temp=new String("");
		boolean eof=false;
		String[] places = new String[113];
		String cname=new String("");
		String temp2=new String("");
		int[] vertex=new int[6];
		int[] weight=new int[6];
		int c=0;
		
		//this first pass through the file just gets the names
		// - the second pass will get all the vertex data
		try {
			reader1 = new FileReader("qwest");
			input1 = new BufferedReader(reader1);
			do {
				temp=input1.readLine();
				if (temp==null) {
					eof=true;
					break;
				}
				
				StringTokenizer tmp= new StringTokenizer(temp,":");
				places[c]=tmp.nextToken();
				c++;
			}
			while (eof==false);
			reader1.close();
		}
		catch (IOException e) {
			System.out.println("There was a file error of some kind.  The error reported was:");			
			System.out.println(e);
		}

		int d=0;
		int j=0;
		int i=0;
		c=0;
		try {
			reader = new FileReader("qwest");
			input = new BufferedReader(reader);
			do {
				for (i=0; i <=5; i++) {
					vertex[i]=0;
					weight[i]=0;
				}
				temp=input.readLine();
				if (temp==null) {
					eof=true;
					break;
				}
				
				StringTokenizer tmp= new StringTokenizer(temp,":,;");
				cname=tmp.nextToken();
				c=0;
				while (tmp.hasMoreTokens()) {
					temp2=tmp.nextToken();
					for (d=0; d < 113; d++) {
						if (places[d].equals(temp2)) {
							vertex[c]=d;
						}
					}
					weight[c]=Integer.parseInt(tmp.nextToken());
					c++;	
				}
				
				this.vertices[j] = new Vertex(cname, vertex, weight);			
				j++;
			}
			while (j < 113);
			reader.close();
		}
		catch (IOException e) {
			System.out.println("There was a file error of some kind.  The error reported was:");			
			System.out.println(e);
		}
		
		int[] tempvert = new int[5];
		int[] tempedge = new int[5];
		for (d=0; d< 113; d++) {
			tempvert=this.vertices[d].getVertex();
			tempedge=this.vertices[d].getEdge();
			for (int e=0; e < 6; e++) 
				if (tempedge[e]==0) 
					this.vertices[d].setVertex(e, -1);
			
			
		}
		
		
		for (c=0; c<113; c++) {
			vertex=this.vertices[c].getVertex();
			weight=this.vertices[c].getEdge();
		}
	}	


		/*
		* method to change the value of an edge connecting 2 vertices
		* -very straightforward, just remember that it changes the edge on 
		* *both* vertices given
		*/
		public void changeEdge() {
			// change weight menu
			// print all cities w/ numbers here
			String city1 = new String("");
			String city2 = new String("");
			String tempstr= new String("");
			int num1=-1;
			int num2=-1;
			int wght = -1;
			for (int i = 0; i < 113; i++) {
				System.out.print(i+":"+this.vertices[i].getName());
				if (i % 4 == 0) 
					System.out.println();
				else
					System.out.print("\t\t");						 
			}
			
			
			try {
				while (!(num1 >=0 && num1 <= 112)) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of first city:");
					tempstr = in2.readLine();
					num1=Integer.parseInt(tempstr);
				}
			
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
			
			int[] tempedge= new int[6];
			int[] tempvert = new int[6];
			tempedge=this.vertices[num1].getEdge();
			tempvert=this.vertices[num1].getVertex();
			for (int i=0; i < 6; i++) {
				if (tempedge[i] > 0)
					System.out.print(tempvert[i] + ":" + this.vertices[tempvert[i]].getName());
				if (i % 3 == 0)
					System.out.println();
				else
					System.out.print("\t");
			}
			try {
				while (!((num2==tempvert[0] && tempedge[0]>0) || (num2==tempvert[1] && tempedge[1]>0) || (num2==tempvert[2] && tempedge[2]>0) || (num2==tempvert[3] && tempedge[3]>0) || (num2==tempvert[4] && tempedge[4]>0) || (num2==tempvert[5] && tempedge[5]>0))) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of second city (select from the given list):");
					tempstr = in2.readLine();
					num2=Integer.parseInt(tempstr);
				}
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
			
			int[] tmpv = new int[6];
			int[] tmpe = new int[6];
			tmpv=this.vertices[num1].getVertex();
			tmpe=this.vertices[num1].getEdge();
			
			for (int i=0; i < 6; i++)
				if (num2==tmpv[i])
					System.out.println("The current weight between the 2 cities is: " + tmpe[i]);		
			
			try {
				while (!(wght >=0)) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter new weight connecting cities:");
					tempstr = in2.readLine();
					wght=Integer.parseInt(tempstr);
				}
				
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
			
			int[] tempedge2=new int[6];
			int[] tempvert2=new int[6];
			tempedge2=vertices[num2].getEdge();
			tempvert2=vertices[num2].getVertex();
			
			for (int i=0; i < 6; i++) {
				if (tempvert[i]==num2) {
					if (wght <=0) {
						this.vertices[num1].setVertex(i,-1);
						this.vertices[num1].setEdge(i,0);
					}
					if (wght > 0)
						this.vertices[num1].setEdge(i,wght);
				}
				
				if (tempvert2[i]==num1) {
					if (wght <=0) {
						this.vertices[num2].setVertex(i,-1);
						this.vertices[num2].setEdge(i,0);
					}
					if (wght > 0) 
						this.vertices[num2].setEdge(i,wght);
				}
				
				
			}
			
			/*
			//begin debug info 
			int[] tempedge3 = new int[6];
			int[] tempvert3 = new int[6];
			int[] tempedge4 = new int[6];
			int[] tempvert4 = new int[6];
			tempedge3=vertices[num1].getEdge();
			tempvert3=vertices[num1].getVertex();
			tempedge4=vertices[num2].getEdge();
			tempvert4=vertices[num2].getVertex();
			
			System.out.print(this.vertices[num1].getName() + ":" + num1 + "\t");
			for (int i=0; i < 6; i++) {
				System.out.print(tempvert3[i] + ":" + tempedge3[i] + "  ");
			}
			System.out.println();
			System.out.print(this.vertices[num2].getName() + ":" + num2 + "\t");
			for (int i=0; i < 6; i++) {
				System.out.print(tempvert4[i] + ":" + tempedge4[i] + "  ");
			}
			//end debug (expendable) stuff	
			*/
		}
		
		/*
		* Depth-First traversal algorithm - opening method of implementation
		*/
		public void DFS() {
			int num1=-1;
			String tempstr=new String("");
			for (int i = 0; i < 113; i++) {
				System.out.print(i+":"+this.vertices[i].getName());
				if (i % 4 == 0) 
					System.out.println();
				else
					System.out.print("\t\t");						 
			}
			
			
			try {
				while (!(num1 >=0 && num1 <= 112)) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of starting city:");
					tempstr = in2.readLine();
					num1=Integer.parseInt(tempstr);
				}
			
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
			
			for (int i=0; i < 113; i++)
				this.dfsFound[i]=0;	
			this.dfsCount=0;
			DFShelp(num1);
         System.out.println();
         System.out.println();

		}		
		
		/*
		* DFS helper method - this is a recursive method where most of the algorithm is implemented
		* --follows the standard DFS path of "going till you can go no more," then backtracking
		*/
		private void DFShelp(int start) {
			int[] vlinks = new int[6];
			vlinks=this.vertices[start].getVertex();
			if (this.dfsFound[start] != 1) {
				this.dfsFound[start]=1;
				System.out.print(this.dfsCount + ":" + this.vertices[start].getName() + " -> ");
				this.dfsCount++;
			}
									
			for (int i=0; i < 6; i++) {
				if (vlinks[i] >= 0 && this.dfsFound[vlinks[i]] != 1)
         		DFShelp(vlinks[i]);
         }   	
         return;
		}
		
		/*
		* start of the Breadth First search algorithm - calls a helper method to handle the *real*
		* process
		*/
		public void BFS() {
			int num1=-1;
			String tempstr=new String("");
			for (int i = 0; i < 113; i++) {
				System.out.print(i+":"+this.vertices[i].getName());
				if (i % 4 == 0) 
					System.out.println();
				else
					System.out.print("\t\t");						 
			}
			
			
			try {
				while (!(num1 >=0 && num1 <= 112)) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of starting city:");
					tempstr = in2.readLine();
					num1=Integer.parseInt(tempstr);
				}
			
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
			
			for (int i=0; i < 113; i++)
				this.bfsFound[i]=0;	
			//this.bfsCount=0;
			
			BFShelp(num1);
		}		
		
		/*
		* BFS helper method - where the BFS is actually implemented.  Follows the standard BFS method 
		* of breaking the problem down into measures of distance from the starting vertex, and sifting
		* through those
		*/
		private void BFShelp(int start) {
			int level=1;
			int bfsvisit=1;
			int[][] index = new int[50][60];  // int[level][next vertex in line]
			int[] indcount = new int[60];
			int[] tmpv = new int[6];
			this.bfsFound[start]=1;
			System.out.println("Level:");
			indcount[0]=1;
			index[0][0]=start;
			System.out.println("0:\t" + this.vertices[start].getName());
			System.out.print("1:\t");
			for (level=1; level < 50; level++) {
				for (int i=0; i < indcount[level-1]; i++) {
					tmpv=this.vertices[index[level-1][i]].getVertex();
					for (int j=0; j < 6; j++) {
						if (tmpv[j] >=0 && this.bfsFound[tmpv[j]]==0) {
							index[level][indcount[level]]=tmpv[j];
							indcount[level]++;
							bfsvisit++;
							System.out.print(this.vertices[tmpv[j]].getName() + " -> ");
							this.bfsFound[tmpv[j]] = 1;
						}
					}
			
				}
				System.out.println();
				if (bfsvisit >=112)
						break;
				System.out.print(level + 1 + ":" + "\t");
			}
			
		}
		
		/*
		* get input and begin the Dijikstra algorithm for finding the shortest path between 2 vertices
		*/
		public void Dijikstra() {
			int num1=-1;
			int num2=-1;
			String tempstr=new String("");
			for (int i = 0; i < 113; i++) {
				System.out.print(i+":"+this.vertices[i].getName());
				if (i % 4 == 0) 
					System.out.println();
				else
					System.out.print("\t\t");						 
			}
			
			
			try {
				while (!(num1 >=0 && num1 <= 112)) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of starting city:");
					tempstr = in2.readLine();
					num1=Integer.parseInt(tempstr);
				}
				while (!(num2 >=0 && num2 <= 112) && (num2!=num1) ) {
					BufferedReader in2 = new BufferedReader(new InputStreamReader(System.in));
					System.out.print("\nEnter number of ending city:");
					tempstr = in2.readLine();
					num2=Integer.parseInt(tempstr);
				}
			
			} 
			catch (IOException e) {
				System.out.println("An error processing your input occured.  Error given was:" + e);
			}
		
			
			Dijhelp(num1,num2);
		}
		
		/*
		* implementation of the Dijikstra algorithm
		* note - many variables used with this one; the important ones related to the algorithm are:
		* -a "focus" vertex that we are currently examining (leader)
		* -a simple priority queue: keeps track of the vertices eligible to become the leader (and thus 
		* move the algorithm forward) (cand[])
		* -a history tracker system: this is implemented using several variables and is used to keep track 
		* of the actual path, in cities (as opposed to just the total number of miles) (candhist[][], candlenhist[],
		* oldLead[])
		*/
		private void Dijhelp(int start, int end) {
			int leader=start;
			int[] candlenhist = new int[113];
			int[][] candhist = new int[113][60];
			int[] cand = new int[113];
		 	int[] oldLead = new int[113];
		 	
		 	int[] tempv = new int[6];
		 	int[] tempe = new int[6];
		 	
		 	candhist[leader][0]=leader;
		 	candlenhist[leader]=1;
			cand[leader]=0;
			
			//first, make neither city is cut off (if they are it generates an exception below)
			tempv= this.vertices[start].getVertex();
			tempe= this.vertices[start].getEdge();
			boolean testAdj=false;
			for (int i=0; i < 6; i++)
				if (tempv[i] >= 0 && tempe[i] > 0)
					testAdj=true;
			if (testAdj==false)
				return;

			tempv= this.vertices[end].getVertex();
			tempe= this.vertices[end].getEdge();
			testAdj=false;
			for (int i=0; i < 6; i++)
				if (tempv[i] >= 0 && tempe[i] > 0)
					testAdj=true;
			if (testAdj==false)
				return;
				
				
			//generic, never-ending loop...
			//it will be exited from with a "break" statement seen below
			while (leader >= 0) {
				tempv= this.vertices[leader].getVertex();
				tempe= this.vertices[leader].getEdge();
				for (int i=0; i < 6; i++) { 
					if (tempv[i] >= 0 && tempe[i] > 0 && oldLead[tempv[i]] <= 0 && tempv[i] != start)
						cand[tempv[i]]= cand[leader]+tempe[i];
				}
				int min=1000000; // easy-to-beat minimum
				int find=-1;
				for (int i=0; i<113; i++) {
					if (cand[i] < min && i != leader && cand[i] > 0) {
						min=cand[i];
						find = i;
					}
				}
				
				oldLead[leader] = cand[leader];
				cand[leader]=0;
				leader=find;
				
				tempv=this.vertices[leader].getVertex();
				
					
				int min2=100000;
				int find2=-1;
				for (int i = 0; i < 6; i++) {
					if (tempv[i] >= 0) {
						if (oldLead[tempv[i]] < min2 && oldLead[tempv[i]] > 0) {
							min2=oldLead[tempv[i]];
							find2=tempv[i];
						}
						if (tempv[i]==start)
							find2=start;
					}
				}
				
				for (int i=0; i <= candlenhist[find2]; i++) {
					candhist[leader][i]=candhist[find2][i];
				}
				
				candlenhist[leader]=candlenhist[find2]+1;
				candhist[leader][candlenhist[leader]]=leader;
				
				
				if (leader==end) {
					System.out.println("\nCONCLUSION: The shortest path is as follows:");
					for (int i=0; i <= candlenhist[leader]; i++) {
						if (i != 1)
							System.out.print(this.vertices[candhist[leader][i]].getName() + "-> ");
					}
					int totaldist=0;
					for (int i=0; i <= candlenhist[leader]; i++) {
						tempv=this.vertices[candhist[leader][i]].getVertex();
						tempe=this.vertices[candhist[leader][i]].getEdge();
							for (int j=0; j < 6; j++) {
								if (i !=0) {	
									if (tempv[j] == candhist[leader][i+1])
										totaldist += tempe[j];
								}
								else {
									if (tempv[j] == candhist[leader][i+2])
										totaldist += tempe[j];
								}
							}
						
					}
					System.out.println();
					System.out.println("\nTotal distance over this path is:" + totaldist);
					break;
				
				}
			}
		}
		

}
