/*
* Makes a simple vertex object which represents a city on the graph
* @author Richard Grube
*/

public class Vertex {
	private int vertex[]; //adjacent vertices of this city (adjacent cities)
	private int edge[]; //length between this city and the corresponding adjacent city
	private String name; //name of this city
	
	/*
	* Constructor to set up our instance variables
	*/
	public Vertex(String nameIn, int[] vertices, int[] edges) {
		this.name= new String(nameIn);
		this.vertex=new int[6];
		this.edge=new int[6];
		for (int i=0; i <=5; i++) {
			this.vertex[i]=vertices[i];
			this.edge[i]=edges[i];
		}
	
	
	}
	
	/*
	* Getter method for city name
	*/
	public String getName() {
		return this.name;
	}
	
	/*
	* Getter method - returns an array of all the vertices adjacent to this one
	* (max 6)
	*/
	public int[] getVertex() {
		return this.vertex;
	}
	
	/*
	* Getter method - returns an array of all the edges incident on this vertex
	* (max 6)
	*/
	public int[] getEdge() {
		return this.edge;
	}
	
	/*
	* Setter method - sets a particular edge's weight that is incident on this vertex
	* (also takes a number 0-5 to tell which edge)
	*/
	public void setEdge(int edgenum, int weight) {
		this.edge[edgenum]=weight;
	}
	
	/*
	* Setter method - sets a particular vertex adjacent to this one
	* (also takes a number 0-5 to tell which vertex in the array to set)
	*/
	public void setVertex(int vertnum, int city) {
		this.vertex[vertnum]=city;
	}
}
